/*

   srnmz.c - ʸƥ Namazu θץ.
   Version 1.1.0    [12/21/97]

   Copyright (C) 1997 Satoru Takabayashi  All rights reserved.
   This is free software with ABSOLUTELY NO WARRANTY.

   Υեܸ EUC ǤʤФʤޤ
*/

/* եȥ */
static char *VERSION = "  Search Program of Namazu Version 1.1.0\n";
static char *COPYRIGHT =
"  Copyright (C) 1997 Satoru Takabayashi All rights reserved.\n\n";
static char *USAGE = "  usage: %s [-nwsvhca] [dir] \"key string\"\n\
     -n (num) : ٤ɽ\n\
     -w (num) : ɽꥹȤƬֹ\n\
     -s       : ûեޥåȤǽ\n\
     -v       : usage ɽ (ɽ)\n\
     -h       : HTML ǽϤ\n\
     -l       : ˵Ū˥Ȥ (ǥեȤǤϥǥ)\n\
     -e       : Ť˵Ū˥Ȥ   (ǥեȤǤϥǥ)\n\
     -a       : ̤򤹤٤ɽ\n";

#ifdef FAST_CGI  /* FastCGI ȤƻȤѤ stdio.h Ȥ */
#include "fcgi_stdio.h"
#else
#include <stdio.h>
#endif  /* FAST_CGI */

#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include <unistd.h>

typedef unsigned char uchar;  /* unsigned char  uchar  */

#ifndef BUFSIZ
#define BUFSIZ 1024
#endif

/* ץबȤ NMZ.* ե֤Ƥǥ쥯ȥ */
#ifdef INDEXDIR
static char *DEFAULT_DIR = INDEXDIR;
#else
static char *DEFAULT_DIR = "/home/ccsatoru/NMZ";
#endif

/* 狼ѥץΥѥ */
#ifdef OPT_PATH_KAKASI
#define KAKASI_PATH OPT_PATH_KAKASI
#else
#define KAKASI_PATH  "/usr/local/bin/kakasi"
#endif
#ifdef OPT_PATH_CHASEN
#define CHASEN_PATH OPT_PATH_CHASEN
#else
#define CHASEN_PATH  "/usr/local/bin/chasen"
#endif

/* 狼ѤΥƥݥեǥ쥯ȥ */
#ifdef TMPDIR
static char *WAKATI_TMP_DIR = TMPDIR;
#else
static char *WAKATI_TMP_DIR = "/tmp";
#endif


/* 狼ѥץΥץ */
#ifdef CHASEN
#define WAKATI_OPT "-F", "%m "
static char *Wakati = CHASEN_PATH;
#endif

#ifdef CHASEN_MORPH
#define WAKATI_OPT "-F", "\%m %H\\n"
static char *Wakati = CHASEN_PATH;
#endif

#ifndef CHASEN
#ifndef CHASEN_MORPH
#define WAKATI_OPT "-ieuc", "-oeuc", "-Ea", "-w"
static char *Wakati = KAKASI_PATH;
#endif
#endif

/* 黻Ҥ */
#define AND_STRING "&"
#define OR_STRING  "|"
#define NOT_STRING "!"		/* NOT Ϥޤ̤ݡ */
#define LP_STRING  "("
#define RP_STRING  ")"

/* ΥץबɬפȤեã̾ */
static char *FLIST = "NMZ.f";
static char *FLISTINDEX = "NMZ.fi";
static char *INDEX = "NMZ.i";
static char *INDEXINDEX = "NMZ.ii";
static char *HASH = "NMZ.h";
static char *HEADERFILE = "NMZ.head";
static char *FOOTERFILE = "NMZ.foot";
static char *LOCKFILE = "NMZ.lock";
static char *LOCKMSGFILE = "NMZ.msg";
static char *BODYMSGFILE = "NMZ.body";

/* ϥå (ܸΥå euctojisput ǽϤޤ) */
static char *TOO_LONG_KEY =
"<H2>顼!</H2>\n<P>Ĺޤ</P>\n";
static char *TOO_MANY_KEYITEM =
"<H2>顼!</H2>\n<P>ιܤ¿ޤ</P>\n";
static char *RESULT = "<H2></H2>\n";
static char *SORRY = "<P>˥ޥåܤϤޤǤ</P>\n";
static char *HIT1 = "<P><STRONG>˥ޥå ";
static char *HIT2 = " ĤιܤĤޤ</STRONG></P>\n\n";
static char *I_HIT_MSG = " (ҥåȿ¿Τ̵뤷ޤ)";
static char *I_MATCH_MSG = " (ޥåñ줬¿Τ̵뤷ޤ)";
static char *ERROR_MSG = "srnmz.c  DEFAULT_DIR ǧƤ\n";
static char *REFERENCE = "ͥҥåȿ: ";
static char *INVALID_DB_NAME = " dbname λǤ";

static char *MIME_HEADER = "Content-type: text/html\n\n";

/* 䤷ʸ */
static char *FORM_INPUT = "<INPUT TYPE=\"TEXT\" NAME=\"key\" ";
static char *FORM_OPTION = "<OPTION ";
static char *FORM_SELECTED = "SELECTED ";
static char *FORM_VALUE = "VALUE=\"";

#define FORM_INPUT_LENG 30
#define FORM_OPTION_LENG 8
#define FORM_SELECTED_LENG 9
#define FORM_VALUE_LENG 7


/*  */
#define KEY_ITEM_MAX    32	/* ιܤκ */
#define SCORE_LINE      1	/* ɽ򤹤Ԥֹ */
#define ABSTRACT_LINE    2	/* ʸƬ()ɽԤֹ */
#define PAGE_MAX       20	/* ̽ϤΥڡκ */
#define IGNORE_HIT  10000	/* ҥåȤܤ¿̵뤹 */
#define IGNORE_MATCH 1000	/* פǤñ줬¿ޥå̵뤹 */
#define RLIST_MAX_MAX  100	/* ٤ˤĤηɽκκ */

#define STDIN 0			/* ɸϤ fd */
#define STDOUT 1		/* ɸϤ fd */


/* Хѿ */

int RListMax = 20;		/* ٤ˤĤη̽Ϥκ */
int RListWhence = 0;		/* ̽ϤƬ */
int Debug = 0;			/* ǥХåѥե饰 -d ץ */
int ShortFormat = 0;		/* ʸƬ()ɽʤʤ 1  */
int ScoreSort = 1;		/* ˤ륽ȤԤʤ 1 */
int HtmlOutput = 1;		/* Ϥ HTML Ǥʤ 1 */
int AllList = 0;		/* 줿٤ƤιܤϤʤ 1 */
int LaterOrder = 1;             /* ¤٤ʤ 1 ݤʤ 0 */
int ForwardMatch = 0;		/* ׸⡼ ON / OFF */
int FinalHitN = 0;		/* ǽŪ˥ҥåȤ */
uchar *ScriptName = "", *QueryString = "";	/* CGI ط */

int Cp = 0;			/* ƵߥѡΥȥݥ¸ѿ */

uchar KeyTable[BUFSIZ];	/* 򵭲ơ֥ */
uchar DbName[BUFSIZ] = "";	/* ǡ١ꤹȤ̾ */
uchar *KeyItem[KEY_ITEM_MAX + 1];		/* γƹܤ򼨤ݥ */
/* 狼񤭥ץȥץ */

FILE *Flist, *FlistIndex, *Index, *IndexIndex, *Header, *Footer, *Hash;


/* CGI ѿѥޥ */
#define safenv( a ) ((cp = getenv( a )) ? cp : empty)
uchar *cp;
uchar *empty = "";


/*
   Ѵ롼
   ƣɧ(K.Sato)  QKC (Quick KANJI code Converter  C Version 1.0) 
   ɤ򻲹ͤˤĺޤ  8/31/97
 */

uchar kanji2nd;

#define ESC 0x1b
static char *NEWJIS_A = "\x1b(J";
static char *NEWJIS_K = "\x1b$B";

#define iskanji1st(c) (((c) >= 0x81 && (c)) <= 0x9f ||\
                      ((c) >= 0xe0 && (c) <= 0xfc))
#define iskanji2nd(c) ((c) >= 0x40 && (c) <= 0xfc && (c) != 0x7f)
#define iseuc(c)  ((c) >= 0xa1 && (c) <= 0xfe)
#define set1byte() fputs( NEWJIS_A, stdout )
#define set2byte() fputs( NEWJIS_K, stdout )


uchar jmstojis(uchar c1, uchar c2)
{
    c1 -= (c1 <= 0x9f) ? 0x70 : 0xb0;
    c1 <<= 1;
    if (c2 < 0x9f) {
	c2 -= (c2 < 0x7f) ? 0x1f : 0x20;
	c1--;
    } else
	c2 -= 0x7e;
    kanji2nd = c2;
    return c1;
}


void jistoeuc(uchar *s)
{
    uchar c, c2;
    int state, i = 0, j = 0;

    state = 0;
    if (!(c = *(s + j++)))
	return;
    while (1) {
	if (c == ESC) {
	    if (!(c = *(s + j++))) {
		*(s + i) = ESC;
		return;
	    }
	    switch (c) {
	    case '$':
		if (!(c2 = *(s + j++))) {
		    *(s + i++) = ESC;
		    *(s + i) = c;
		    return;
		}
		if (c2 == 'B' || c2 == '@')
		    state = 1;
		else {
		    *(s + i++) = ESC;
		    *(s + i++) = c;
		    c = c2;
		    continue;
		}
		break;

	    case '(':
		if (!(c2 = *(s + j++))) {
		    *(s + i++) = ESC;
		    *(s + i) = c;
		    return;
		}
		if (c2 == 'J' || c2 == 'B' || c2 == 'H')
		    state = 0;
		else {
		    *(s + i++) = ESC;
		    *(s + i++) = c;
		    c = c2;
		    continue;
		}
		break;

	    case 'K':
		state = 1;
		break;

	    case 'H':
		state = 0;
		break;

	    default:
		*(s + i++) = c;
		continue;
	    }
	} else if (c <= 0x20 || c == 0x7f) {
	    *(s + i++) = c;
	} else if (state) {
	    if (!(c2 = *(s + j++))) {
		*(s + i) = c;
		return;
	    }
	    if (c2 <= 0x20 || c2 == 0x7f) {
		*(s + i++) = c;
		c = c2;
		continue;
	    }
	    *(s + i++) = c | 0x80;
	    *(s + i++) = c2 | 0x80;
	} else {
	    *(s + i++) = c;
	}
	if (!(c = *(s + j++))) {
	    *(s + i) = (uchar) NULL;
	    return;
	}
    }
}

void sjistoeuc(uchar *s)
{
    uchar c, c2;
    int i = 0, j = 0;

    if (!(c = *(s + j++)))
	return;
    while (1) {
	if (c < 0x80)
	    *(s + i++) = c;
	else if (iskanji1st(c)) {
	    if (!(c2 = *(s + j++))) {
		*(s + i) = c;
		return;
	    }
	    if (iskanji2nd(c2)) {
		c = jmstojis(c, c2);
		*(s + i++) = (c | 0x80);
		*(s + i++) = (kanji2nd | 0x80);
	    } else {
		*(s + i++) = c;
		*(s + i++) = c2;
	    }
	} else
	    *(s + i++) = c;
	if (!(c = *(s + j++)))
	    return;
    }
}


void euctojisput(uchar *s, int mode)
{
    int c, c2, state = 0;

    if (!(c = (int) *(s++)))
	return;
    while (1) {
	if (c < 0x80) {
	    if (state) {
		set1byte();
		state = 0;
	    }
	    if (mode) {
		/* < > & " ξϼλȤѴƽϤޤ */
		if (c == '<')
		    printf("&lt;");
		else if (c == '>')
		    printf("&gt;");
		else if (c == '&')
		    printf("&amp;");
		else if (c == '"')
		    printf("&quot;");
		else
		    fputc(c, stdout);
	    } else
		fputc(c, stdout);
	} else if (iseuc(c)) {
	    if (!(c2 = (int) *(s++))) {
		fputc(c, stdout);
		return;
	    }
	    if (!state) {
		set2byte();
		state = 1;
	    }
	    if (iseuc(c2)) {
		fputc(c & 0x7f, stdout);
		fputc(c2 & 0x7f, stdout);
	    } else {
		fputc(c, stdout);
		set1byte();
		state = 0;
		fputc(c2, stdout);
	    }
	} else {
	    if (state) {
		set1byte();
		state = 0;
	    }
	    fputc(c, stdout);
	}
	if (!(c = (int) *(s++))) {
	    if (state)
		set1byte();
	    return;
	}
    }
}

#ifdef WIN32

unsigned char jistojms(unsigned char c1, unsigned char c2)
{
    if (c1 & 1) {
        c1 = (c1 >> 1) + 0x71;
        c2 += 0x1f;
        if (c2 >= 0x7f)
            c2++;
    }
    else {
        c1 = (c1 >> 1) + 0x70;
        c2 += 0x7e;
    }
    if (c1 > 0x9f)
        c1 += 0x40;
    kanji2nd = c2;
    return c1;
}

void euctosjis(unsigned char *s)
{
    unsigned char c, c2;
    int i = 0, j = 0;

    if (!(c = *(s + j++)))
        return;

    while (1) {
        if (iseuc(c)) {
            if (!(c2 = *(s + j++))) {
                *(s + i++) = c;
                return;
            }
            if (iseuc(c2)) {
                c = jistojms(c & 0x7f, c2 & 0x7f);
                *(s + i++) = c;
                *(s + i++) = kanji2nd;
            }
            else {
                *(s + i++) = c;
                *(s + i++) = c2;
            }
        }
        else
            *(s + i++) = c;
        if (!(c = *(s + j++)))
            return;
    }
}

#endif  /* #ifdef WIN32 */


/* ǥХåѤΥؿ */
void error(char *msg)
{
    fprintf(stderr, "Error!\n %s\n", msg);
    exit(1);
}

/* ΥץѤ᥿饯Ƥߤؿ */
int ismetastring(uchar *c)
{
    if ((!strcmp(c, AND_STRING)) ||
	(!strcmp(c, OR_STRING)) ||
	(!strcmp(c, NOT_STRING)) ||
	(!strcmp(c, LP_STRING)) ||
	(!strcmp(c, RP_STRING)))
	return 1;
    return 0;
}

/* HTML ӽʤϤ 
   Win32 ʤ SJIS ǽϤ */
void fputs_without_html_tag(uchar *s)
{
    int f, i;
    uchar buf[BUFSIZ];

    for (f = 0, i = 0 ;*s && i < BUFSIZ; s++) {
        if (!strncmp(s, "<BR>", 4)) {
            buf[i++] = '\n';
            s += 3;
            continue;
        }
        if (*s == '<') { f = 1; continue; }
        if (*s == '>') { f = 0; continue; }
        if (!f) {
            if (!strncmp(s, "&lt;", 4)) { 
                buf[i++] = '<';
                s += 3;
            } else if (!strncmp(s, "&gt;", 4)) { 
                buf[i++] = '>';
                s += 3;
            } else if (!strncmp(s, "&amp;", 5)) { 
                buf[i++] = '&';
                s += 4;
            } else {
                buf[i++] = *s;
            }
        }
    }
    buf[i] = (uchar)NULL;
#ifdef WIN32
    euctosjis(buf);
#endif
    fputs(buf, stdout);
}

/* NMZ.body  */
void put_body_msg(void)
{
    uchar buf[BUFSIZ];
    FILE *bodymsg;

    if ((bodymsg = fopen(BODYMSGFILE, "rb"))) {
        while (fgets(buf, BUFSIZ, bodymsg))
            fputs(buf, stdout);
        fclose(bodymsg);
    }
}

/* ܤȤˤ櫓ؿ(䤱ĹʤäƤޤä) */
int keysplit(uchar *qs)
{
    int i, qn;

    if (strlen(qs) >= BUFSIZ - 1) {
	if(HtmlOutput) euctojisput(TOO_LONG_KEY, 0);
        else fputs_without_html_tag(TOO_LONG_KEY);
	return 1;
    }
    /* ʸ */
    for (i = 0; *(qs + i); i++)
	*(qs + i) = tolower(*(qs + i));

    strcpy(KeyTable, qs);

    /* ιܿ */
    for (i = 0, qn = 0; *(KeyTable + i);) {
	while (KeyTable[i] == ' ')
	    i++;
	if (KeyTable[i])
	    qn++;
	while (KeyTable[i] != ' ' &&
	       KeyTable[i] != (uchar) NULL)
	    i++;
    }

    if (Debug)
	fprintf(stderr, "KeyItemN: %d\n", qn);

    /* ιܤ¿饨顼ǥ꥿ */
    if (qn > KEY_ITEM_MAX) {
	euctojisput(TOO_MANY_KEYITEM, 0);
	return 1;
    }
    /* ιܤʤ饨顼ǥ꥿ */
    if (qn == 0) {
        if(HtmlOutput)put_body_msg();
	return 1;
    }
    /* γƹܤ˥ݥ󥿤դꡢơ֥ NULL  */
    for (i = 0, qn = 0; KeyTable[i];) {
	while (KeyTable[i] == ' ')
	    i++;
	if (KeyTable[i])
	    KeyItem[qn++] = &KeyTable[i];
	while (KeyTable[i] != ' ' &&
	       KeyTable[i] != (uchar) NULL)
	    i++;
	if (KeyTable[i])
	    KeyTable[i++] = (uchar) NULL;
    }

    /* ƥκǸ NULL  */
    KeyItem[qn] = (uchar *) NULL;

    return 0;
}


/* NULL Τʤʸ󤫤ͤ */
int numberget(uchar *qs)
{
    int i;
    uchar buf[BUFSIZ];

    for (i = 0; isdigit(*(qs + i)); i++)
	buf[i] = *(qs + i);
    buf[i] = (char) NULL;
    return atoi(buf);
}

/* header  footer ɽ ξ줷ΤŪ롼 */
void headfootcat(FILE * fp, uchar *ks)
{
    int i;
    uchar *tmp, buf[BUFSIZ];

    while (fgets(buf, BUFSIZ, fp)) {
	if (!strncmp(buf, FORM_INPUT, FORM_INPUT_LENG)) {
	    /* printf ȴĤΤ fputs ȤäƤޤ */
	    fputs(FORM_INPUT, stdout);
	    fputs(FORM_VALUE, stdout);
	    euctojisput(ks, 1);
	    fputs("\" ", stdout);
	    for (i = FORM_INPUT_LENG; *(buf + i); i++)
		if (!strncmp(buf + i, "SIZE=", 5))
		    break;
	    fputs(buf + i, stdout);
	} else if (!strncmp(buf, FORM_OPTION, FORM_OPTION_LENG)) {
	    tmp = buf;
	    tmp += FORM_OPTION_LENG;
	    if (!strncmp(tmp, FORM_SELECTED, FORM_SELECTED_LENG))
		tmp += FORM_SELECTED_LENG;
	    if (!strncmp(tmp, FORM_VALUE, FORM_VALUE_LENG))
		tmp += FORM_VALUE_LENG;
	    fputs(FORM_OPTION, stdout);
	    if (!strncmp(tmp, "short", 5) && ShortFormat)
		fputs(FORM_SELECTED, stdout);
	    else if (!strncmp(tmp, "long", 4) && (!ShortFormat))
		fputs(FORM_SELECTED, stdout);
	    else if (!strncmp(tmp, "score", 5) && ScoreSort)
		fputs(FORM_SELECTED, stdout);
	    else if (!strncmp(tmp, "later", 5) && LaterOrder && !ScoreSort)
		fputs(FORM_SELECTED, stdout);
	    else if (!strncmp(tmp, "earlier", 7) && !LaterOrder && !ScoreSort)
		fputs(FORM_SELECTED, stdout);
	    else if (*DbName && !strncmp(tmp, DbName, strlen(DbName)))
		fputs(FORM_SELECTED, stdout);
	    else if (numberget(tmp) == RListMax)
		fputs(FORM_SELECTED, stdout);
	    fputs(FORM_VALUE, stdout);
	    fputs(tmp, stdout);
	} else {
	    fputs(buf, stdout);
	}
    }
    rewind(fp);
}


/* ǥå򻲾Ȥ֤ͤ */
long indexpointer(FILE * fp, long p)
{
    int val;

    fseek(fp, p * sizeof(int), 0);
    fread(&val, sizeof(int), 1, fp);

    return (long) val;
}

/* Debug ѥơ */
void status(int l, int r)
{
    uchar buf[BUFSIZ];

    fseek(Index, indexpointer(IndexIndex, l), 0);
    fgets(buf, BUFSIZ, Index);
    fprintf(stderr, "l:%d: %s", l, buf);
    fseek(Index, indexpointer(IndexIndex, r), 0);
    fgets(buf, BUFSIZ, Index);
    fprintf(stderr, "r:%d: %s", r, buf);
}

/* ӥåǥ 2 byte ɤ */
#define big_endian_2byte( key ) ((int)((*key << 8) | *(key + 1)))

/* üȱü */
void lrget(uchar *key, int *l, int *r)
{
    int tmp;

    if (*(key + strlen(key) - 1) == '*') {
	*(key + strlen(key) - 1) = (uchar) NULL;
	ForwardMatch = 1;
    } else
	ForwardMatch = 0;

    /* üȱüϥåŪ˼ */
    tmp = big_endian_2byte(key);
    *l = indexpointer(Hash, tmp);
    *r = indexpointer(Hash, ++tmp) - 1;
    if (ForwardMatch && *l > *r)
	*r = *l;

    if (Debug)
	status(*l, *r);
}

/* ʬõΥᥤ롼 */
int binsearch(uchar *key)
{
    int l, r, x, e = 0, i;
    uchar buf[BUFSIZ];

    lrget(key, &l, &r);
    while (r >= l) {
	x = (l + r) / 2;

	fseek(Index, indexpointer(IndexIndex, x), 0);

	/* BUFSIZ (ɸ1024) ۤ褦ʥɤϺޤ */
	fgets(buf, BUFSIZ, Index);
	if (Debug)
	    fprintf(stderr, "searching: %s", buf);
	for (e = 0, i = 0; *(buf + i) != '\n' && *(key + i); i++) {
	    if (*(buf + i) > *(key + i)) {
		e = -1;
		break;
	    }
	    if (*(buf + i) < *(key + i)) {
		e = 1;
		break;
	    }
	}

	if (*(buf + i) == '\n' && *(key + i))
	    e = 1;
	if (!ForwardMatch && *(buf + i) != '\n' && (!*(key + i)))
	    e = -1;

	/* ҥåȤƤ */
	if (!e)
	    return x;

	if (e < 0)
	    r = x - 1;
	else
	    l = x + 1;
    }
    return -1;
}


/* ҥåȥꥹȤμ */
int *gethlist(void)
{
    int *hlist, n;

    fread(&n, sizeof(int), 1, Index);

    if (n > IGNORE_HIT * 2) {
	if ((int *) NULL ==
	    (hlist = (int *) malloc(1 * sizeof(int))))
	     error("hlist");
    } else {
	if ((int *) NULL ==
	    (hlist = (int *) malloc((n + 1) * sizeof(int))))
	     error("hlist");
	fread(hlist + 1, sizeof(int), n, Index);
    }
    *hlist = n;
    return hlist;

}

/* ʥȤǤޡȤȤ 
   Υɤϸ@ޥϤĺޤ [11/13/97]
*/

void nmz_mergesort(int first, int last, int *hlist, int *work)
{
    int middle;
    static int i, j, k, p;

    if (first < last) {
	middle = (first + last) / 2;
	nmz_mergesort(first, middle, hlist, work);
	nmz_mergesort(middle + 1, last, hlist, work);
	p = 0;
	for (i = first; i <= middle; i++) {
	    work[p * 2] = hlist[i * 2];
	    work[p * 2 + 1] = hlist[i * 2 + 1];
	    p++;
	}
	i = middle + 1;
	j = 0;
	k = first;
	while (i <= last && j < p) {
	    if (work[j * 2 + 1] >= hlist[i * 2 + 1]) {
		hlist[k * 2] = work[j * 2];
		hlist[k * 2 + 1] = work[j * 2 + 1];
		k++;
		j++;
	    } else {
		hlist[k * 2] = hlist[i * 2];
		hlist[k * 2 + 1] = hlist[i * 2 + 1];
		k++;
		i++;
	    }
	}
	while (j < p) {
	    hlist[k * 2] = work[j * 2];
	    hlist[k * 2 + 1] = work[j * 2 + 1];
	    k++;
	    j++;
	}
    }
}

/* ޡȤƤӽФ */
void sorthlist(int *hlist)
{
    int *work;
    if (ScoreSort) {
	work = (int *) malloc(sizeof(int) * FinalHitN + 2);
	nmz_mergesort(0, FinalHitN - 1, &hlist[1], work);
	free(work);
    }
}


/* ҥåȥꥹȤν */
void puthlist(int *hlist)
{
    int i, j, sc, hlistmax;
    uchar buf[BUFSIZ];

    if (!hlist)
	return;

    sorthlist(hlist);
    hlistmax = *hlist;

    for (i = RListWhence * 2 + 1; i < hlistmax ; i += 2) {
	if (!AllList && (i >= RListWhence * 2 + RListMax * 2)) break;
	sc = *(hlist + i + 1);
	fseek(Flist, indexpointer(FlistIndex, *(hlist + i)), 0);

	for (j = 0;; j++) {
	    if (!fgets(buf, BUFSIZ, Flist) || *buf == '\n') {
		fputc('\n', stdout);
		break;
	    }
	    if (j == ABSTRACT_LINE && ShortFormat)
		continue;

	    *(buf + strlen(buf) - 1) = (uchar) NULL;
	    if(HtmlOutput) fputs(buf, stdout);
            else {
                jistoeuc(buf);
                fputs_without_html_tag(buf);
            }
	    if (j == 0) {
		printf("%d. ", i / 2 + 1);
		continue;
	    }
	    if (j == SCORE_LINE)
		printf(" (score: %d)", sc);
	    fputc('\n', stdout);
	}
    }
}




/* left  right  AND ǥޡؿ */
int *andmerge(int *left, int *right, int *ignore)
{
    int i, j, v;

    if (*ignore && left)
	return left;
    if (*ignore && right)
	return right;

    if (!left || !right)
	return (int *) NULL;


    for (v = 1, i = 1, j = 1; i < *left; i += 2) {
	for (;; j += 2) {
	    if (j > *right)
		goto OUT;
	    if (*(left + i) < *(right + j))
		break;
	    if (*(left + i) == *(right + j)) {

		/* left  right  ξ */

		*(left + v) = *(left + i);
		*(left + v + 1) = *(left + i + 1) < *(right + j + 1) ?
		    *(left + i + 1) : *(right + j + 1);
		v += 2;
		j += 2;
		break;
	    }
	}
    }
  OUT:
    free(right);
    *left = v - 1;
    return left;
}


/*
   left  right  OR ǥޡؿ
 */
int *ormerge(int *left, int *right)
{
    int i, j, v, *val, n = 0;

    if (!left && !right)
	return (int *) NULL;
    if (!left)
	return right;
    if (!right)
	return left;

    n = *left + *right + 1;

    if ((int *) NULL ==
	(val = (int *) malloc(n * sizeof(int))))
	 error("val( ormerge )");

    for (v = 1, i = 1, j = 1; i < *left; i += 2) {
	for (; *(left + i) >= *(right + j) && j < *right; j += 2) {
	    if (*(left + i) == *(right + j)) {

		/* left  right 礭ۤ */

		*(left + i + 1) = *(left + i + 1) > *(right + j + 1) ?
		    *(left + i + 1) : *(right + j + 1);
		j += 2;
		break;
	    } else {
		*(val + v) = *(right + j);
		*(val + v + 1) = *(right + j + 1);
		v += 2;
	    }
	}
	*(val + v) = *(left + i);
	*(val + v + 1) = *(left + i + 1);
	v += 2;
    }

    for (; j < *right; j += 2) {

	*(val + v) = *(right + j);
	*(val + v + 1) = *(right + j + 1);
	v += 2;
    }


    free(left);
    free(right);
    *val = v - 1;
    return val;
}



/* ׸ */
int *forwardmatch(uchar *key, int v, int *val)
{
    int i, j, ignore = 0, n, *tmp;
    uchar buf[BUFSIZ];

    n = strlen(key);

    for (i = v; i >= 0; i--) {
	fseek(Index, indexpointer(IndexIndex, i), 0);
	fgets(buf, BUFSIZ, Index);
	if (strncmp(key, buf, n))
	    break;
    }
    if (Debug)
	v = i;

    for (j = 0, i++;; i++, j++) {
	/* ñ줬¿ޥå 
	   (Ȥ a* ʤƤޤȤ˽Ѥ) */
	if (j > IGNORE_MATCH) {
	    free(val);
	    return (int *) NULL;
	}
	if (-1 == fseek(Index, indexpointer(IndexIndex, i), 0))
	    break;
	fgets(buf, BUFSIZ, Index);
	if (!strncmp(key, buf, n)) {
	    tmp = gethlist();
	    if (Debug)
		fprintf(stderr, "fw: %s", buf);
	    if (*tmp > IGNORE_HIT * 2) {
		ignore = *tmp;
		free(val);
		free(tmp);
		break;
	    }
	    val = ormerge(val, tmp);
	    if (*val > IGNORE_HIT * 2) {
		ignore = *val;
		free(val);
		free(tmp);
		break;
	    }
	} else
	    break;
    }
    if (ignore) {
	if ((int *) NULL ==
	    (val = (int *) malloc(1 * sizeof(int))))
	     error("val( forwardmatch )");
	*val = ignore;
    }
    if (Debug)
	fprintf(stderr, "range: %d - %d\n", v + 1, i - 1);

    return val;
}


/* Ƶߥѡ expr, orop, term, andop, fator
   Perl ץߥ (饯) 򻲹ͤˤޤ
 */
int *expr(), *term(), *factor(), orop(), andop();

int *factor(int *ignore)
{
    int v, *val = (int *) NULL;

    if (!KeyItem[Cp])
	return val;

    if (!strcmp(KeyItem[Cp], LP_STRING)) {
	Cp++;
	if (KeyItem[Cp] == (uchar *) NULL)
	    return val;
	val = expr();
	if (KeyItem[Cp] == (uchar *) NULL)
	    return val;
	if (!strcmp(KeyItem[Cp], RP_STRING))
	    Cp++;
    } else if (!ismetastring(KeyItem[Cp])) {
	if ((v = binsearch(KeyItem[Cp])) != -1) {
	    /* ⤷ĤäꥹȤ롣
	       ޤвνϤԤ */
	    val = gethlist();
	    if (ForwardMatch)
		val = forwardmatch(KeyItem[Cp], v, val);
	    printf(" [ ");
	    if (HtmlOutput) euctojisput(KeyItem[Cp], 1);
            else fputs_without_html_tag(KeyItem[Cp]);
	    if (ForwardMatch)
		fputc('*', stdout);
	    if (val)
		printf(": %d", *val / 2);

	    if (val == (int *) NULL) {
		if (HtmlOutput) euctojisput(I_MATCH_MSG, 0);
		else fputs_without_html_tag(I_MATCH_MSG);
		*ignore = 1;
	    } else if (*val > IGNORE_HIT * 2) {
		free(val);
		if (HtmlOutput) euctojisput(I_HIT_MSG, 0);
		else fputs_without_html_tag(I_HIT_MSG);
		val = (int *) NULL;
		*ignore = 1;
	    }
	    printf(" ] ");
	} else {
	    printf(" [ ");
	    if (HtmlOutput) euctojisput(KeyItem[Cp], 1);
	    else fputs_without_html_tag(KeyItem[Cp]);
	    if (ForwardMatch)
		fputc('*', stdout);
	    printf(": 0 ] ");
	}
	Cp++;
    }
    return val;
}

int andop(void)
{
    if (KeyItem[Cp] == (uchar *) NULL)
	return 0;
    if (!strcmp(KeyItem[Cp], AND_STRING)) {
	Cp++;
	return 1;
    }
    if (!ismetastring(KeyItem[Cp]))
	return 1;
    return 0;
}

int *term(void)
{
    int *left, *right, ignore = 0;

    left = factor(&ignore);
    while (andop()) {
	right = factor(&ignore);
	left = andmerge(left, right, &ignore);
    }
    return left;
}


int orop(void)
{
    if (KeyItem[Cp] == (uchar *) NULL)
	return 0;
    if (!strcmp(KeyItem[Cp], OR_STRING)) {
	Cp++;
	return 1;
    }
    return 0;
}

int *expr(void)
{
    int *left, *right;

    left = term();
    while (orop()) {
	right = term();
	left = ormerge(left, right);
    }
    return left;
}


/*
   pageindex ѥ꡼
 */
void queryput(uchar *qs, int w)
{
    while (*qs) {
	if (!strncmp(qs, "whence=", 7)) {
	    printf("whence=%d", w);
	    for (qs += 7; isdigit(*qs); qs++);
	} else
	    fputc(*(qs++), stdout);
    }
}

/* ڡǥåɽ */
void putpageindex(int n)
{
    int i;

    if (HtmlOutput) printf("<STRONG>Page:</STRONG> ");
    else printf("Page: ");
    for (i = 0; i < PAGE_MAX; i++) {
	if (i * RListMax * 2 >= n)
	    break;
	if (HtmlOutput) {
            if (i * RListMax != RListWhence) {
                printf("<A HREF=\"");
                fputs(ScriptName, stdout);
                fputc('?', stdout);
                queryput(QueryString, i * RListMax);
                printf("\">");
            } else {
                printf("<STRONG>");
            }
        }
	printf("[%d]", i + 1);
	if (HtmlOutput) {
            if (i * RListMax != RListWhence) {
                printf("</A> ");
            } else
                printf("</STRONG> ");
        }
        if(AllList) break;
    }
}

/* ɽƤꥹȤϰϤɽ */
void putcurrentextent(int listmax)
{
    if (HtmlOutput) printf("<STRONG>Current List: %d", RListWhence + 1);
    else printf("Current List: %d", RListWhence + 1);
    if (HtmlOutput) euctojisput("  ", 0);
    else fputs_without_html_tag("  ");
    if (!AllList && ((RListWhence + RListMax) < listmax))
	printf("%d", RListWhence + RListMax);
    else
	printf("%d", listmax);
    if (HtmlOutput) printf("</STRONG><BR>\n");
    else fputc('\n', stdout);
}

/* 
  ̤ΥꥹȤսˤ 
  Υ롼ϸ@ޥϤĺޤ [11/13/97]
*/
void hlist_reverse(int *hlist)
{
    int m, n, tmp1, tmp2;
    m = 2 - 1;
    n = FinalHitN * 2 - 1;
    while (m < n) {
        tmp1 = hlist[m];
        tmp2 = hlist[m + 1];
        hlist[m] = hlist[n];
        hlist[m + 1] = hlist[n + 1];
        hlist[n] = tmp1;
        hlist[n + 1] = tmp2;
        m += 2;
        n -= 2;
    }
}

/* ή椹ؿ */
void searchmain(void)
{
    int *hlist;

    if (HtmlOutput) euctojisput(RESULT, 0);
    else fputs_without_html_tag(RESULT);
    if (HtmlOutput) fputs("<P>\n", stdout);
    else fputc('\n',stdout);
    if (HtmlOutput) euctojisput(REFERENCE, 0);
    else fputs_without_html_tag(REFERENCE);
    Cp = 0;
    hlist = expr();
    if(HtmlOutput) printf("\n</P>\n");
    else fputc('\n',stdout);

    if (hlist)
	FinalHitN = *hlist / 2;
    else
	FinalHitN = 0;
    if (FinalHitN && LaterOrder)
        hlist_reverse(hlist);
    if (hlist && *hlist) {
	/* ҥåȤϤ */
	if (HtmlOutput) euctojisput(HIT1, 0);
	else fputs_without_html_tag(HIT1);
	printf("%d", *hlist / 2);
	if (HtmlOutput) euctojisput(HIT2, 0);
	else fputs_without_html_tag(HIT2);

	if(HtmlOutput) printf("<DL>\n");
	puthlist(hlist);
	if(HtmlOutput) printf("</DL>\n");

	if(HtmlOutput) printf("<P>\n");
	putcurrentextent(*hlist / 2);
	putpageindex(*hlist);
	if(HtmlOutput) printf("</P>\n");
        else printf("\n");
	free(hlist);
    } else {
	if (HtmlOutput) euctojisput(SORRY, 0);
	else fputs_without_html_tag(SORRY);
	if (hlist)
	    free(hlist);
    }
}


/* եƤ˳ݤΤʤؿ */
void filesopen(void)
{
    if (NULL == (Flist = fopen(FLIST, "rb")))
	error(FLIST);
    if (NULL == (FlistIndex = fopen(FLISTINDEX, "rb")))
	error(FLISTINDEX);
    if (NULL == (Index = fopen(INDEX, "rb")))
	error(INDEX);
    if (NULL == (IndexIndex = fopen(INDEXINDEX, "rb")))
	error(INDEXINDEX);
    if (NULL == (Hash = fopen(HASH, "rb")))
	error(HASH);
    if (NULL == (Header = fopen(HEADERFILE, "rb")))
	error(HEADERFILE);
    if (NULL == (Footer = fopen(FOOTERFILE, "rb")))
	error(FOOTERFILE);

}

/* եޤȤĤľʴؿ */
void filesclose(void)
{
    fclose(Flist);
    fclose(FlistIndex);
    fclose(Index);
    fclose(IndexIndex);
    fclose(Hash);
    fclose(Header);
    fclose(Footer);
}


/* Ȥӥɽƽλ */
void usage(char *argv0)
{
    uchar buf[1024];
    strcpy(buf, USAGE);
#ifdef WIN32
    euctosjis(buf);
#endif
    fputs(VERSION, stdout);
    fputs(COPYRIGHT, stdout);
    printf(buf, argv0);
    exit(0);
}



/* ʸɤμưȽ(ʤľ) */
int codeconv(uchar *in)
{
    int i, m, n, f;

    for (i = 0, m = 0, n = 0, f = 0; *(in + i); i++) {
	if (*(in + i) == ESC) {
	    jistoeuc(in);
	    return 1;
	}
	if (*(in + i) > (uchar) '\x80')
	    m++, f = f ? 0 : 1;
	else if (f) {
	    sjistoeuc(in);
	    return 1;
	}
	if (*(in + i) > (uchar) '\xa0')
	    n++;
    }
    if (m != n) {
	sjistoeuc(in);
	return 1;
    }
    if (n)
	return 1;
    return 0;
}

/* URLencode  decode  */
/* c & 0xdf  c ʸˤƤ */
uchar URLencode(uchar c, uchar c2)
{

    c = ((c >= 'A' ? ((c & 0xdf) - 'A') + 10 : (c - '0'))) * 16;
    c += (c2 >= 'A' ? ((c2 & 0xdf) - 'A') + 10 : (c2 - '0'));
    return c;
}


/*  CGI ѿ Фäʥ롼*/
int cgiparamget(uchar *keystring)
{
    int i;
    uchar *qs;

    if (!(ScriptName = getenv("SCRIPT_NAME")))
	return 0;
    if (!(QueryString = getenv("QUERY_STRING")))
	return 0;

    qs = QueryString;
    while (*qs) {
	if (!strncmp(qs, "key=", 4)) {
	    qs += 4;

	    for (i = 0; *qs && *qs != '&' && i < BUFSIZ - 1; qs++, i++) {
		if (*qs == '%') {
		    *(keystring + i) = URLencode(*(qs + 1), *(qs + 2));
		    qs += 2;
		} else if (*qs == '+')
		    *(keystring + i) = ' ';
		else
		    *(keystring + i) = *qs;

	    }
	    *(keystring + i) = (uchar) NULL;
	    qs++;
	} else if (!strncmp(qs, "format=short&", 13)) {
	    ShortFormat = 1;
	    qs += 13;
	} else if (!strncmp(qs, "sort=", 5)) {
            qs += 5;
            if (!strncmp(qs, "score", 5)) {
                ScoreSort = 1;
                qs += 5;
            } else if (!strncmp(qs, "later", 5)) {
                LaterOrder = 1;
                ScoreSort = 0;
                qs += 5;
            } else if (!strncmp(qs, "earlier", 7)) {
                LaterOrder = 0;
                ScoreSort = 0;
                qs += 7;
            }
	    while (*qs && *qs != '&')
		qs++;
	    qs++;
	} else if (!strncmp(qs, "max=", 4)) {
	    qs += 4;
	    RListMax = numberget(qs);
	    if (RListMax < 0)
		RListMax = 0;
	    if (RListMax > RLIST_MAX_MAX)
		RListMax = RLIST_MAX_MAX;
	    while (*qs && *qs != '&')
		qs++;
	    qs++;
	} else if (!strncmp(qs, "whence=", 7)) {
	    qs += 7;
	    RListWhence = numberget(qs);
	    if (RListWhence < 0)
		RListWhence = 0;
	    while (*qs && *qs != '&')
		qs++;
	    qs++;
	} else if (!strncmp(qs, "dbname=", 7)) {
	    qs += 7;
	    for (i = 0; *qs && *qs != '&' && i < BUFSIZ - 1; i++, qs++)
		DbName[i] = *qs;
	    DbName[i] = (uchar) NULL;
	    qs++;
	} else
	    qs++;
    }
    return 1;
}

/* βԥɤӶ */
void chop(uchar *s)
{
    int i;
    for (i = strlen(s) - 1; i >= 0; i--) {
        if (*(s + i) == '\n' || *(s + i) == ' ' || *(s + i) == '\r') 
	    *(s + i) = (uchar) NULL;
	else
	    break;
    }
}


#ifdef WIN32

/* Win32 Ǥ fork systemܸ狼񤭥ץƤӽФ */
/* @ٻΥե椵󤫤ĺޤ [11/13/97] */

void wakati2(unsigned char *ks)
{
    int status, i;
    FILE *ftmp1, *ftmp2;
    int n;
    unsigned char tmp[BUFSIZ];
    char *tmp1 = "wakachi.tmp";
    char *tmp2 = "wakachi2.tmp";
#ifdef CHASEN_MORPH
    char *cmd  = "chasen -F \"\%m %H\\n\" -j wakachi.tmp > wakachi2.tmp";
#else
    char *cmd  = "chasen -F \"\%m \" -j wakachi.tmp > wakachi2.tmp";
#endif
    char noun[] = { 0x96 , 0xbc , 0x8e , 0x8c }; /* SJISɤ̾ */

    if (NULL == (ftmp1 = fopen(tmp1, "wb")))
        error("wakati tmp1");
    fprintf(ftmp1, "%s", ks);
    fclose(ftmp1);

    system(cmd);

    if (NULL == (ftmp2 = fopen(tmp2, "r")))
	error("tmp2( wakati ) fopen");

    *ks = (unsigned char)NULL;
    n = 0;
#ifdef CHASEN_MORPH
    while (fgets(tmp, BUFSIZ,  ftmp2))
    {
	for (i=0; tmp[i] != ' ' && tmp[i];i++);
	if (tmp[i] != ' ') continue;
	i++;
	if (strncmp(tmp + i, noun, 4)) continue;
	n += i;
	if (n > BUFSIZ - 1) break;
	strncat(ks, tmp, i);
    }
#else
    fgets(ks, BUFSIZ, ftmp2);
#endif  /* #ifdef CHASEN_MORPH */
    chop(ks);
    fclose(ftmp2);

    return;
}

#else  /* #ifdef WIN32 */

/* fork ܸ狼񤭥ץƤӽФ */
void wakati(uchar *ks)
{
    int status, fd, fds[2], pp, tp, i;
    pid_t pid;
    uchar *tmpf;
    FILE *fp;
#ifdef CHASEN_MORPH
    int n;
    uchar tmp[BUFSIZ];
#endif

    if (pipe(fds))
	error("pipe");

    if ((pp = fork()) == 0) {
	close(STDOUT);
	dup(fds[1]);
	close(fds[0]);
	close(fds[1]);
 	write(STDOUT, ks, strlen(ks));
	exit(0);
    }
    if (pp < 0)
	error("fork");

    tmpf = tempnam(WAKATI_TMP_DIR, "wktmp");


    if ((tp = fork()) == 0) {

	if (-1 == (fd = open(tmpf, O_CREAT | O_WRONLY, 00600)))
	    error("tmpf( wakati )");
	close(STDOUT);
	free(tmpf);
	dup(fd);
	close(fd);

	close(STDIN);
	dup(fds[0]);
	close(fds[0]);
	close(fds[1]);

	execl(Wakati, Wakati, WAKATI_OPT, 0);
	exit(1);
    }
    if (tp < 0)
	error("fork");
    close(fds[0]);
    close(fds[1]);

    for (i = 0; i < 2;) {
	pid = wait(&status);
	if (pid == pp || pid == tp)
	    i++;
    }

    if (NULL == (fp = fopen(tmpf, "rb")))
	error("tmpf( wakati ) fopen");

#ifdef CHASEN_MORPH
    *ks = (uchar) NULL;
    n = 0;
    while (fgets(tmp, BUFSIZ, fp)) {
	for (i = 0; tmp[i] != ' ' && tmp[i]; i++);
	if (tmp[i] != ' ')
	    continue;
	i++;
	if (strncmp(tmp + i, "̾", 4))
	    continue;
	n += i;
	if (n > BUFSIZ - 1)
	    break;
	strncat(ks, tmp, i);
    }
#else
    fgets(ks, BUFSIZ, fp);
#endif				/* CHASEN_MORPH */
    chop(ks);
    fclose(fp);
    unlink(tmpf);
    free(tmpf);

    return;
}

#endif  /* #ifdef WIN32 */

/*  EUC 롣Ťѥå򤢤Ƥ 
   kakasi -Ea -w  '0xa4' Хۼ 
   ĤǤ ܸ kakasi ʬ򤹤 '*' ΥƤޤΤ㳰 */

void correcteuc(uchar *ks)
{
    int i, j, f;

    for (i = 0, j = 0, f = 0; *(ks + i); i++) {
	if (i > 2 && *(ks + i) == '*' && iseuc(*(ks + i - 2)))
	    j--;
	if (f) {
	    f = 0;
	    if (!iseuc(*(ks + i)))
		j--;
	} else if (iseuc(*(ks + i)))
	    f = 1;
	*(ks + j++) = *(ks + i);
    }
    if (f)
	j--;
    *(ks + j) = (uchar) NULL;
}



#ifndef SLOGOFF

#define SLOG  "NMZ.slog"

/* Υؿ
   ƥȽصθƽϤ EUC ˤƤޤ */

void slog(uchar *ks)
{
    FILE *slog;
    char *rhost;
    char *time_string;
    time_t t;

    t = time(&t);
    time_string = ctime(&t);

    if (NULL == (slog = fopen(SLOG, "a")))
	error(SLOG);
    rhost = safenv("REMOTE_HOST");
    if (!*rhost)
	rhost = safenv("REMOTE_ADDR");
    fprintf(slog, "%s\t%d\t%s\t%s", ks, FinalHitN, rhost, time_string);

    fclose(slog);
}

#endif	/* ifndef SLOGOFF */

/* åե뤬뤫Ĵ٤롣 NMZ.msg Ϥƽλ */
void lockfilecheck(void)
{
    FILE *lock, *lockmsg;
    char buf[BUFSIZ];

    if ((lock = fopen(LOCKFILE, "rb"))) {
	fclose(lock);
	fputs(MIME_HEADER, stdout);
	if (NULL == (lockmsg = fopen(LOCKMSGFILE, "rb")))
	    error(LOCKMSGFILE);
	while (fgets(buf, BUFSIZ, lockmsg))
	    fputs(buf, stdout);
	fclose(lockmsg);
	exit(0);
    }
}

/* ͭ dbname ڤ ('/' ޤޤƤǤ) */
int validdbname(uchar *dbname)
{
    for (; *dbname; dbname++) {
	if (*dbname == '/') {
	    fputs(MIME_HEADER, stdout);
	    euctojisput(INVALID_DB_NAME, 0);
	    exit(0);
	}
    }
    return 1;
}

/*
   2 bytes ѿ 1 byte Ѵ롼 
   ΥɤϤޤ餵ĺޤ [9/28/97]
 */
char Z2H[] = "\0 \0\0,.\0:;?!\0\0'`\0^~_\0\0\0\0\0\0\0\0\0\0\0\0/\\\0\0|\0\0`'\"\"()\0\0[]{}<>\0\0\0\0\0\0\0\0+-\0\0\0=\0<>\0\0\0\0\0\0\0'\"\0\\$\0\0%#&*@";
void zen2han(uchar *s)
{
    int p = 0, q = 0, r;
    while (*(s + p)) {
	if (*(s + p) == 0xa1) {
	    r = *(s + p + 1) - 0xa0;
	    if (r <= sizeof(Z2H) && Z2H[r] != '\0') {
		p++;
		*(s + p) = Z2H[r];
	    } else {
		*(s + q) = *(s + p);
		q++;
		p++;
	    }
	} else if (*(s + p) == 0xa3) {
	    p++;
	    *(s + p) = *(s + p) - 128;
	} else if (*(s + p) & 0x80) {
	    *(s + q) = *(s + p);
	    p++;
	    q++;
	}
	*(s + q) = *(s + p);
	p++;
	q++;
    }
    *(s + q) = '\0';
}

/* ޥɥ饤󥪥ץ */
int command_line_opt(int ac, uchar *av[])
{
    int i;

    for (i = 1; i < ac; i++) {
        if (*av[i] == '-') {
            switch (tolower(*(av[i] + 1))) {
            case 'n':
                if (i < ac - 2)
                    RListMax = atoi(av[++i]);
                break;
            case 'w':
                if (i < ac - 2)
                    RListWhence = atoi(av[++i]);
                break;
            case 'd':
                Debug = 1;
                break;
            case 's':
                ShortFormat = 1;
                break;
            case 'c':
                ScoreSort = 0;
                break;
            case 'h':
                HtmlOutput = 1;
                break;
            case 'a':
                AllList = 1;
                break;
            case 'l':
                LaterOrder = 1;
                ScoreSort = 0;
                break;
            case 'e':
                LaterOrder = 0;
                ScoreSort = 0;
                break;
            case 'v':
                usage(av[0]);

            }
        } else {
            break;
        }
    }
    return i;
}

/* ȸޤȤ᤿롼
   ¤ FastCGI б뤿صŪˤޤȤ᤿Ȥ */
void namazu_core(uchar *keystring)
{
    if (Debug) {
	fprintf(stderr, " -n: %d\n", RListMax);
	fprintf(stderr, " -w: %d\n", RListWhence);
	fprintf(stderr, "key: %s\n", keystring);
    }

    if (codeconv(keystring)) {
#ifdef WIN32
	zen2han(keystring);
 	euctosjis(keystring);
 	wakati2(keystring);
 	sjistoeuc(keystring);
 	correcteuc(keystring);
#else
#ifndef CHASEN  /* ChaSen Ȥϼ->Ⱦѥ */
	zen2han(keystring);
#endif
#ifndef CHASEN_MORPH
	zen2han(keystring);
#endif
	wakati(keystring);
	correcteuc(keystring);
#endif  /* #ifdef WIN32 */

    }

    if (HtmlOutput) fputs(MIME_HEADER, stdout);
    if (HtmlOutput) headfootcat(Header, keystring);
    if (!keysplit(keystring))
	searchmain();
    if(HtmlOutput) headfootcat(Footer, keystring);

#ifndef SLOGOFF
    slog(keystring);
#endif
}


/* CGI ǸƤӽФ줿ȤΥ˥饤 
  ºݤˤϥޥɥ饤󤫤ʤǸƤФ줿Ȥ⤳̲᤹ */
void cgi_initialize(uchar *keystring, uchar *argv0)
{
    if (!cgiparamget(keystring))
        usage(argv0);   /* CGI ʤȽ usage ɽ */
    if (-1 == chdir(DEFAULT_DIR)) {
        fputs(MIME_HEADER, stdout);
        printf("Can't chdir to %s\n", DEFAULT_DIR);
        euctojisput(ERROR_MSG, 0);
        exit(1);
    }
    if (DbName[0] && validdbname(DbName) && (-1 == chdir(DbName))) {
        fputs(MIME_HEADER, stdout);
        printf("Can't chdir to %s\n", DbName);
        exit(1);
    }
}

/* main ؿ */
int main(int ac, uchar *av[])
{
    int i = 0, is_cgi = 0;
    uchar keystring[BUFSIZ] = "";

#ifdef FAST_CGI
    uchar before_dbname[BUFSIZ] = "";
    int f = 0;
#endif

    if (ac == 1) {
        is_cgi = 1;  /* ʤ CGI Ȳꤹ */
    } else {
        HtmlOutput = 0; /* ޥɥ饤ϥǥեȤǤ HTML Ϥʤ */
        i = command_line_opt(ac, av); 	/* ޥɥ饤󥪥ץν */
	if (i == ac)
	    usage(av[0]);

	/* оݥǥ쥯ȥذư */
	if (i <= ac - 2) {
	    if (-1 == chdir(av[i]))
		error(av[i]);
	    i++;
	} else {
	    if (-1 == chdir(DEFAULT_DIR))
		error(DEFAULT_DIR);
	}
	if (strlen(av[i]) >= BUFSIZ - 1) {
	    euctojisput(TOO_LONG_KEY, 0);
	    return 1;
	}
	strcpy(keystring, av[i]);
    }
    lockfilecheck();

#ifdef FAST_CGI
    /* FastCGI ȤΤ褦ʥ롼פˤʤΤǤޤ
       ĤޤץϽλʤԵƼΥꥯȤԤĤΤǤ
       */
    while(FCGI_Accept() >= 0) {
        if (is_cgi) cgi_initialize(keystring, av[0]);
        if (!DbName[0] && !f) {
            filesopen();
            f = 1;
        } else if (strcmp(before_dbname, DbName)) {
            /* ǡ١λ꤬ȰäȤϥե򳫤ľ */
            if (f) filesclose();
            filesopen();
            f = 1;
#ifdef FAST_CGI_DEBUG
            puts(MIME_HEADER);
            printf("DB Changed! DbName:[%s] before[%s]\n", DbName, before_dbname);
#endif
            strcpy(before_dbname, DbName);
        }
        namazu_core(keystring);
#ifdef FAST_CGI_DEBUG
        printf("Counter:(%d) ", i++);
#endif
        keystring[0] = (uchar)NULL;
    }
#else /* Normal CGI */
    /* ̾ CGI ϥå fork & exec ǸƤФ˻ */
    if (is_cgi) cgi_initialize(keystring, av[0]);
    filesopen();
    namazu_core(keystring);
    filesclose();
#endif /* FAST_CGI */


    return 0;
}
